  MEMBER

  include('JtCmDna.inc'),once
  include('JtCmDnaZebra.inc'),once

  map
  end

JtCmDnaZebraClass.AddStripe PROCEDURE(SHORT Col,LONG Normal = -1,LONG Stripe = -1)
PutRec  BYTE
  CODE
  PutRec = SELF.IsColorCol(Col)
  SELF.Options.Col      = Col
  SELF.Options.Normal   = Normal
  SELF.Options.Stripe = Stripe
  if PutRec
    put(SELF.Options)
  else
    add(SELF.Options,+SELF.Options.Col)
  end
 
JtCmDnaZebraClass.Changed PROCEDURE
Changes LONG
  CODE
  Changes = changes(SELF.DDQ)
  if Changes <> SELF.Changes
    SELF.Changes = Changes
    return 1
  else
    return 0
  end

JtCmDnaZebraClass.Cols PROCEDURE
Counter  SHORT,AUTO
  CODE
  Counter = 0
  loop
    Counter += 1
    if not SELF.Feq{PROPLIST:Exists,Counter}
      Counter -= 1
      break
    end
  end
  return(Counter)

JtCmDnaZebraClass.Construct PROCEDURE
  CODE
  SELF.Options &= new JtCmDnaZebraColourOptionQ

JtCmDnaZebraClass.Destruct PROCEDURE
  CODE
  free(SELF.Options)
  dispose(SELF.Options)

JtCmDnaZebraClass.IsColorCol PROCEDURE(SHORT Col)
  CODE
  SELF.Options.Col = Col
  get(SELF.Options,SELF.Options.Col)
  if errorcode()
    return(False)
  else  
    return(True)
  end  

JtCmDnaZebraClass.Init PROCEDURE(WINDOW w,SIGNED Feq,QUEUE Ddq)
  CODE
  SELF.DDQ &= Ddq
  SELF.Init(w,Feq)
  SELF.Changes = changes(SELF.DDQ)
  
JtCmDnaZebraClass.Rows PROCEDURE
  CODE
  return(records(SELF.DDQ))

JtCmDnaZebraClass.Splice PROCEDURE(LONG Row,SHORT Col)
  CODE
  get(SELF.DDQ,Row)
  if not SELF.IsColorCol(Col)
    return what(SELF.DDQ,Col)
  else
    return choose(what(SELF.DDQ,Col) <> -1,what(SELF.DDQ,Col),choose(not band(row,1),SELF.Options.Normal,SELF.Options.Stripe))
  end
  